<?php
/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/
define('OTOGI_X', 0);
define('OTOGI_Y', 1);
define('OTOGI_FORMSIGN', 'otogi-settings');
//define('OTOGI_STAGE_INITILIZE', '\\-[]\*[]\\_r\\_p');

$gOtogiStory;
$gOtogiChara;
$gOtogiField;
$gOtogiComments=array('','','','-1');

$YENBSLASH=chr(194).chr(165);//C2, A5
$BSLASH=chr(165);//A5
$YEN=chr(92);//5C

define('OTOGI_YEN', chr(92)); //5C
define('OTOGI_BSLASH', chr(165)); //A5
define('OTOGI_YB', chr(194).chr(165)); //A4, A5

define('OTOGI_BSLASH_MAC', chr(180)); //B4 //UTF-8 "更" の3バイト目


$isTB=false;

$otogi_debug;

include(TEMPLATEPATH. '/lib-php/OtogiStory.php');

function Otogi_Ajax(){
define('DOING_AJAX', true);
	if(isset($_REQUEST['otogi'])):
		$q=$_REQUEST['otogi'];
		if($q == 'config'){
		// 全体設定
		// 基本的にheader.phpの<script>で行うが、XHTMLの<![CDATA[ ]]>で不具合が出る場合に使用。
			include(TEMPLATEPATH . '/lib-php/config-js.php');

		}else{
			include(TEMPLATEPATH . '/lib-php/ajax.php');

		}
		exit();
	endif;
}//Otogi_Ajax
add_action('get_header', 'Otogi_Ajax');


/****
****/
function Otogi_Ajax_Comment($arg){
define('DOING_AJAX', true);
	global $gOtogiComments;
	$gOtogiComments[3]=$arg;
@header('Content-Type: text/plain; charset=' . get_option('blog_charset'));
send_nosniff_header();
	include(TEMPLATEPATH .'/lib-php/comment-post.php');
	exit();
}//Otogi_Ajax_Comment
add_action('comment_post', 'Otogi_Ajax_Comment');


/****
****/
function Otogi_Ajax_Die($message, $title, $args){
define('DOING_AJAX', true);
	global $gOtogiComments;
	$gOtogiComments[3]=-2; // todo:エラーIDをdefineで調整
	$gOtogiComments[1]=$message;
	$gOtogiComments[2]=$title;
	@header('Content-Type: text/plain; charset=' . get_option('blog_charset'));
	send_nosniff_header();
	include(TEMPLATEPATH .'/lib-php/comment-post.php');
	exit();
}// Otogi_Ajax_Die
add_action('wp_die_handler', 'Otogi_Ajax_Die');


function Otogi_Ajax_Comment_Duplicate($commentdata){
define('DOING_AJAX', true);
	Otogi_Ajax_Die('コメント重複', '', $commentdata);
	exit();
}
add_action('comment_duplicate_trigger', 'Otogi_Ajax_Comment_Duplicate');

/********/
function OtogiContent($content=''){
	global $gOtogiStory;
	global $isTB;
	static $evenodd=false;

	$gOtogiStory=new OtogiStory($content);
	$gOtogiStory->Expand();
	return ($isTB)?$gOtogiStory->excerpt:'';
}

/********/
function OtogiExcerpt($content=''){
	global $gOtogiStory;

	if(!isset($gOtogiStory)){
		$gOtogiStory=new OtogiStory($content);
		$gOtogiStory->Expand();
	}
	return $gOtogiStory->Excerpt();
}//

add_filter('the_content', 'OtogiContent');
add_filter('the_excerpt', 'OtogiExcerpt');
add_filter('the_excerpt_rss', 'OtogiExcerpt');

/******************************
 * 管理メニューにキャラクター管理ページへのリンクを表示
******************************/
function otogi_addmin_menu() {
include(TEMPLATEPATH. '/lib-php/OtogiChara.php');
include(TEMPLATEPATH. '/lib-php/OtogiField.php');
	global $gOtogiChara, $gOtogiField;
	if(!isset($gOtogiChara))
		$gOtogiChara=new OtogiChara();
	if(!isset($gOtogiField))
		$gOtogiField=new OtogiField();

	if ( isset( $_GET['page'] ) && $_GET['page'] == basename(__FILE__) ) {
		if ( isset( $_REQUEST['action'] ) && $_REQUEST['action'] == 'save' ) {
			check_admin_referer('otogi_options_name');
		
		if(isset($_REQUEST[OTOGI_FORMSIGN])){
			$q=$_REQUEST[OTOGI_FORMSIGN];

			if($q == 'charactor'){
			// キャラクター保存
				$gOtogiChara->SaveChara($_REQUEST['otogi-id'], $_REQUEST['otogi-name'], $_REQUEST['otogi-basex'], $_REQUEST['otogi-basey'], $_REQUEST['otogi-default']);

			}elseif($q == 'posture'){
			// ポーズ追加

				$otogi_pid=$gOtogiChara->SavePosture($_REQUEST['otogi-id'], $_REQUEST['otogi-posture-id'], '', '', $_REQUEST['otogi-posture-name'], $_REQUEST['otogi_polex'], $_REQUEST['otogi_poley'], 'input');
				
			}elseif($q == 'stand'){
			// 立ち位置調整
				$gOtogiChara->SaveStand();
			
			}elseif($q == 'scene'){
			// シーン追加
				$id=$_REQUEST['otogi-scene-id'];
				$name=$_REQUEST['otogi-scene-name'];

				$id=$gOtogiField->SaveScene($id, '', $name, 'file');

			}elseif($q == 'defaultscene'){
			// デフォルトシーン
				$id=$_REQUEST['otogi-scene-default'];
				$id=$gOtogiField->SaveDefaultScene($id);

			
			}elseif($q == 'onoma'){
			// シーン追加
				$id=$_REQUEST['otogi-onoma-id'];
				$name=$_REQUEST['otogi-onoma-name'];
				$id=$gOtogiField->SaveOnoma($id, '', $name, 'file');

			}elseif($q == 'freetalk'){
			// フリートークカテゴリー
				$names=$_REQUEST['otogi_freetalk'];
				if(empty($names)){
					$names=array();
				}
				update_option('otogi-freetalk', implode(',', $names));

			// ナビゲーター
				$navis=$_REQUEST['otogi_navigators'];
				if(empty($navis)){
					$navis=array();
				}
				update_option('otogi-navigators', implode(',', $navis));

			}elseif($q == 'export'){
			// エクスポート
				$gOtogiChara->Export();
				$gOtogiField->Export();

			} else {

			}
		}//if(isset($_REQUEST[OTOGI_FORMSIGN]){
		}//if ( isset( $_REQUEST['action'] ) && 'save' == $_REQUEST['action'] ) {
		add_action('admin_head', 'otogi_admin_head');
		add_action('admin_footer', 'otogi_admin_footer');

	}//if ( isset( $_GET['page'] ) && $_GET['page'] == basename(__FILE__) ) {
	add_theme_page('おとぎ芝居設定', 'おとぎ芝居設定', 'edit_themes', basename(__FILE__), 'otogi_admin_page');
}//

add_action('admin_menu', 'otogi_addmin_menu');

function otogi_admin_head() {
?>
<script type="text/javascript" src="<?php bloginfo( 'template_directory' ); ?>/lib-js/dabten.js"></script>
<script type="text/javascript" src="<?php bloginfo( 'template_directory' ); ?>/lib-js/slider.js"></script>
<script type="text/javascript" src="<?php bloginfo( 'template_directory' ); ?>/lib-js/jquery-1.4.2.min.js"></script>
<script type="text/javascript" src="<?php bloginfo( 'template_directory' ); ?>/lib-js/jquery-ui-1.8.4.custom.min.js"></script>
<script type="text/javascript" src="<?php bloginfo( 'template_directory' ); ?>/lib-js/u.js"></script>
<script type="text/javascript" src="<?php bloginfo( 'template_directory' ); ?>/lib-js/admin/admin.js"></script>
<script type="text/javascript" src="<?php bloginfo( 'template_directory' ); ?>/lib-js/admin/edit.js"></script>
<script type="text/javascript">
</script>
<link href="<?php bloginfo( 'template_directory' ); ?>/lib-css/admin/style.css" type="text/css" rel="stylesheet"/>
<?php
}  //function

/******************************
 * キャラクター管理ページ
******************************/

function otogi_admin_page() {
	include(TEMPLATEPATH . '/lib-php/admin/admin.php');
} // function


function otogi_admin_edit($arg1) {
	include(TEMPLATEPATH . '/lib-php/admin/edit.php');
} // function

function otogi_admin_footer() {
	include(TEMPLATEPATH . '/lib-php/admin/footer.php');
} // function


/****
 URLからotogi=idを消す
****/
function otogi_get_pagenum_link($url){
	$url=preg_replace('/otogi=[0-9-]+/', '', $url);
	return preg_replace('/&#038;&#038;/', '&#038;', $url);
}
add_filter('get_pagenum_link', 'otogi_get_pagenum_link');

/****/

/****
ライブラリ
****/

/****
ファイルパスからファイル名を取得する。
pathinfo()の日本語対応版
パスの分割は":/\"に対応、戻り値のdirnameのパス区切りは"/"固定。
****/
function pathinfo_japanese($path){
	// ファイル名作成
	$ret=array("filename"=>"", "basename"=>"","extension"=>"","dirname"=>"");

	$tmp = preg_split("/[\\\\:\\/]/", $path);
	$ret["basename"] = array_pop($tmp);
	$ret["dirname"]= implode("/", $tmp);
	$tmp = explode('.', $ret["basename"]);
	$ret["extension"]=array_pop($tmp);
	$ret["filename"]=implode(".", $tmp);

	return $ret;
}


function otogi_checked( $class, $value = '' ) {
	echo ('' != $value && in_array($value, $class) )?' checked="checked"':'';
}


?>