/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/
function Balloon(fld, cha, srf, pos){
	var chara=cha;
	var serif=srf;
	var start=(new Date()).getTime();
	var tm=0;
	var tWait=B_LETTER_INTERVAL;
	this.isFast=0;//0:normal, 1:fast, 2:one-time-fast

	var self=this;
	
	var frame=U.CE('div');
	with(frame){
		className='balloon';
		style.position='absolute';
		style.display='none';
		
		// chaにあわせて場所を調整
		if(pos){
			if(pos.hasOwnProperty('top'))style.top=pos.top;
			if(pos.hasOwnProperty('bottom'))style.bottom=pos.bottom;
			if(pos.hasOwnProperty('left'))style.left=pos.left;
			if(pos.hasOwnProperty('right'))style.top=pos.right;
		}
		
	}
	
	fld.appendChild(frame);

	var output;
	NewOutput()

	/****/
	this.Init=function(){
		var xy=chara.GetPos();
		var wh=U.GetSize(frame.parentNode);
		frame.style.bottom=(wh.h-xy.y)+'px';
		frame.style.left=xy.x+'px';
		return this;
	};//

	/****/
	this.Destroy=function(){
		RemoveChild(frame, true);
		delete self;
		return this;
	};//
	
	/****/
	this.SetClass=function(name, oldName){
		var cn=' '+frame.className+' ';
		cn=cn.replace(' '+name+' ', ' ');
		if(oldName){
			cn=cn.replace(RegExp(' ?'+oldName+' ?'), ' ');
		}
		cn+=name;
		frame.className=cn.replace(/^ | $/, '');
		return this;
	};//
	/****
	this.SetClass=function(name, oldName){
		var cn=' '+frame.className+' ';
		cn=cn.replace(' '+name+' ', '');
		if(oldName)
			cn=cn.replace(' '+oldName+' ', name).replace(/ $/, '');
		else
			cn+=name;
		frame.className=cn;
		
		return this;
	};//
	
	/****/
	this.SetStyle=function(ss){
		for(var s in ss)
			frame.style[s]=ss[s];
		
		return this;
	};//

	/****/
	this.MoveTop=function(){
		var pa=frame.parentNode;
		pa.appendChild(pa.removeChild(frame));
		return this;
	};//
	
	/****/
	this.GetSize=function(){
		return U.GetSize(frame);
	};//
	
	/****/
	this.Close=function(){
		frame.style.display='none';
		return this;
	};//
	
	/****/
	this.Show=function(cl){
		if(tm)tm=clearTimeout(tm);
		if(cl){
			this.Clear();
		}
		frame.style.display='block';
		return this;
	};//
	
	/****/
	this.MoveTo=function(x, y){
		frame.style.top=y+'px';
		frame.style.left=x+'px';
		frame.style.bottom='';
		frame.style.right='';
		return this;
	};//
	
	/****/
	this.MoveToR=function(x, y){
		frame.style.right=x+'px';
		frame.style.bottom=y+'px';
		frame.style.top='';
		frame.style.left='';
		return this;
	};//
	
	/****/
	this.Serif=function(s){
		serif=s;
		return this;
	};//
	
	this.Clear=function(){
		frame.innerHTML='';
		NewOutput();
		return this;
	};//
	
	
	/****
	****/
	this.Run=function(quick){
		var c;
		if(!serif.length){
			return 0;
		}
		
		c=serif.charAt(0);
		if(c==YEN){
			serif=serif.substring(1);
			c=serif.charAt(0);
		}

		if(quick||U.EI('fastplay').isFast=='1'){
			Talk(serif);
			serif='';
		}else{
			Talk(c);
			serif=serif.substring(1);
		}
		if(!serif.length)
			this.AutoClose();
		
		return serif.length;
	};//

	/****
	****/
	function Talk(c){
		if(c=='\n')
			NewOutput();
		else if(Config.tcon)
			output.textContent+=c;
		else
			output.innerText+=c;
		
	};//

	/****
	todo:停止中はクローズしないようにする
	****/
	this.AutoClose=function(){
		if(tm)
			return this;
		tm=setTimeout(self.Close, B_CLOSE_INTERVAL);
		return this;
	};//

	function NewOutput(){
		output=null;
		output=U.CE('p');
		with(output){
			className='serif';
		}
		frame.appendChild(output);
	}
}//Balloon

