/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/
function Seats(){
	Field.apply(this, arguments);

// フィールド情報
	var self=null;
	
	var now=0;
	var lastAction={
			talktime:0
		};

	this.isRun=false;
	this.start=0;

	var comment_sum=0; // コメントの件数

//初期設定など

	/****/
	this.Load=function(ftype, ctype){
		var div;
		
		this.field=U.CE('div');
		this.field.className=this.className;
		this.field.id=this.id;

		if(document && document.body){
			document.body.appendChild(this.field);
		}
		
		Dabten.InsertHTML(this.field, 'seats', {base:AJAX_BASE_URL});

		this.SetupForm(null);
		
		delete this.Load;
		return this;
	};//
	
	
/**
**/
	this.LoadCharas=function(data){
		this.Clear();
		this.AddCharas(data, false);
		return this;
	};//

	this.AddCharas=function(data, play){
		if(!data)
			return this;

		if(play && this.sLine>=comment_sum){
			this.sLine=comment_sum-1;
			this.script=(new Date()).getTime();
		}
		
		for(var i=0;c=data[i];i++){
			this.charas[i+comment_sum]=new Audience(c, i*1000);
		}//for
		comment_sum+=data.length;
		
		if(play && !this.isRun){
			this.isRun=true;
		}
		return this;
	};//

/****
Actionからのタイマー呼び出し
話中かどうかのチェック
戻り値
true: 会話中
false: 会話終了
****/
	this.Play=function(interval){
		var now=(new Date()).getTime()-this.script;

		if(	(this.sLine===-1) || //-1:強制終了
			(comment_sum===this.sLine) || //コメント全員終了
			(!comment_sum) //コメントなし
		){
			this.isRun=false;
			return false;
		}

		var cnt=0;
		var c=0;
		var P=function(n){
			var re={
				id:n,
				left:0,
				top:0,
				marginTop:-24
			};
			
			var l=n%7;
			var t=parseInt(n/7);
			
			re.top=-t*32-32*(1+parseInt(l/4));
			re.margin=-re.top-44+(Math.floor(Math.random()*32)) // 吹き出し32、<p>のmargin-bottom
			re.left=(l>3)?90+(l-4)*185:l*185;
			
			return re;
		};
		
		for(var i in this.charas){
			var rc=this.charas[i].Talk(now, P(c));
			if(rc===-1){
			//まだ開始時間になってない、これ以降はすべて開始時間になってないので終了する
				this.sLine=c;
				return true;
			}
			cnt+=+!rc;//トーク終了したキャラをカウント
			c++;
		}

		this.sLine=cnt;
		if(cnt==comment_sum){
		//全部終了している
			this.isRun=false;
			return false;
		}
		
		return true;
	};
	
	//コメントフォーム
	this.SetupForm=function(data){
		var div=this.field.lastChild;
		
		var frm=U.EI('seatsinput_form');
		frm.comment.value='';
		frm.comment_post_ID.value=(data)?data.comment_post_ID:'';
		frm.uid.value=(data)?data.uid:'';
		U.EI('comment_form_action').innerHTML=(data && data.comment_form_action)?data.comment_form_action:'';
		
		var author=(data && data.author)?data.author:'';
		var email=(data && data.email)?data.email:'';

		var disp=(!data || data.uid=='' || data.uid<1)?'block':'none';
		for(var i=0,elms=U.EC('required', U.EI('seatsinput'));i<elms.length;i++){
			elms[i].style.display=disp;
		}
		frm.author.value=author;
		frm.email.value=email;
	};
	
	// 客席をクリア、コメントフォームを非表示
	this.Hide=function(t){
		var t=0;
		for(var i in this.charas){
			this.charas[i].Clear();
		}
		this.DisplayForm('none');
		return this;
	};
	// コメントフォームを表示
	this.Show=function(){
		this.DisplayForm('block');
		return this;
	};
	
	this.DisplayForm=function(disp){
		for(var i=0,elms=U.EC('required', U.EI('seatsinput'));i<elms.length;i++){
			elms[i].style.display=disp;
		}
		U.EI('seatsinput_form').style.display=disp;
		return this;
	};

	this.Clear=function(){
		for(var i in this.charas){
			this.charas[i].Destroy();
			delete this.charas[i];
		}
		comment_sum=0;
		return this;
	};

	this.SetZIndex=function(z){
		this.field.style.zIndex=z;
		return this;
	};//

};//
U.Inherit(Seats, Field);


function Audience(data, t) {
	//プロパティ
	this.name=data.name;
	this.date=data.date;
//	this.time=t=(function(t){var hm=t.split(':');return Number(hm[0])*60+Number(hm[1]);})(data.time);
this.time=t;
	this.finished=15000;// バルーンを消すまでの時間（ミリ秒）
	this.figure=U.CE('div');
	
	//吹出し
	var balloon=U.CE('p');
	this.figure.appendChild(balloon);
	//balloon.className='balloon';
	var mq=U.CE('marquee');
	balloon.appendChild(mq);
	mq.appendChild(U.CT(data.script.replace('<p>','').replace('</p>','')));

	//アバター
	var avatar=U.CE('img');
	this.figure.appendChild(avatar);
	avatar.src=(function(s){return (s.match(/src=["'](.+?)["']/))?RegExp.$1:'';})(data.avatar);
}

/****
コメントトーク
****/
Audience.prototype.Talk=function(t,o){
	var fig=this.figure;
	if(t<=this.time){
	// 時間前
		return -1;
	}else if(t>=this.finished){
	// トーク開始後から15秒経過
		var pa=fig.parentNode;
		if(pa)
			pa.removeChild(fig);
		return 0;
	}
	//トーク開始
	if(!fig.parentNode || fig.parentNode!=seats.field.getElementsByTagName('*')[0]){
		seats.field.getElementsByTagName('*')[0].appendChild(fig);
		fig.style.top=o.top+'px';
		fig.style.left=o.left+'px';
		fig.lastChild.style.marginTop=o.margin+'px';
	}
	
	//途中
	return 1;
};

//アイコン表示、ResetAllPoseエミュレート
Audience.prototype.SetPose=function(){return true;};
Audience.prototype.CloseBalloon=function(){return true;};
Audience.prototype.ClearBalloon=function(){return true;};

Audience.prototype.Clear=function(){
	var fig=this.figure;
	if(fig.parentNode)
		fig.parentNode.removeChild(fig);
	return true;
};
//オブジェクト破棄
Audience.prototype.Destroy=function(){
	RemoveChild(this.figure, true);
	delete this.figure;
	return true;
};

