/*******************
おとぎ芝居 (fairy rhyme) (Ver. 2.0)
Copyright 神崎渉瑠, 2008-2011
http://www.wi-wi.jp/
********************/

/***********************/


function Otogi(){
	this.scriptArea='scriptArea';
	this.tplScriptArea=''
+'<div id="otogiscriptarea" class="otogiedit"><p><textarea name="otogiscript" id="otogiscript" style="width:100%;height:20em;">{tpl:content}</textarea></p>'
+'<div><select id="charas" onchange="otogi.OtogiChange();"><option value="luty">るてぃ</option><option value="lity">りてぃ</option><option value="taru">たる</option></select>'
+'<select id="poses" onchange="otogi.OtogiChange();"><option value="0">0</option><option value="1">1</option><option value="2">2</option></select>'
+'<img src="{tpl:basurl}/images/spacer.gif" id="otogichara" width="50" height="50" style="border:1px solid black;" />'
+'</div></div>';

	this.tbsArea='tbsArea';
	this.tplTbsArea=''
+'<div id="otogitbsarea" class="otogiedit"><fieldset>'
+'<label for="otogitbttl">タイトル <input name="otogitbttl" id="otogitbttl" style="width:100%;height:1.5em;" value="{tpl:ttl}" /></label><br />'
+'<label for="otogitburl">URL <input name="otogitburl" id="otogitburl" style="width:100%;height:1.5em;" value="{tpl:url}" /></label><br />'
+'<label for="otogitbquote"><textarea name="otogitbquote" id="otogitbquote" style="width:100%;height:10em;">{tpl:quote}</textarea></label><br />'
+'</fieldset></div>';

	this.script='';
	this.boards=[];
	this.tbs=[];
	
	Dabten.Set(this.scriptArea, this.tplScriptArea);
	Dabten.Set(this.tbsArea, this.tplTbsArea);
	
	delete this.tplScriptArea;
	delete this.tplTbsArea;

	this.Init=function(){
		Dabten.InsertDOM('postdiv', this.scriptArea,
			{
			 content:this.script
			,baseurl: AJAX_BASE_URL
			}
			,true
		);
		Dabten.InsertDOM('trackbacksdiv', this.tbsArea,
			{
			 ttl:TRACKBACK_TTL
			,url:TRACKBACK_URL
			,quote:TRACKBACK_QUOTE
			,baseurl: AJAX_BASE_URL
			}
			,true
		);
	};//
	
	this.OnLoad=function(){
		var div=U.CE('div');
		div.innerHTML='広告などの投稿欄';
		
//		alert('onload');
	};//
	
	this.Set=function(id, str){
		if(id=='boards'){
			this.boards.push(str);
		}else if(id=='tbs'){
			this.tbs.push(this.SetupTbl(str));
		}else if(id=='script'){
			this.script=str.replace(/\\n\\n/g, '\n');
		}
		return this;
	};//
	
	this.SetupTbl=function(str){
		var tb={
			 ttl:''
			,url:''
			,quote:''
		};
		var p1=str.indexOf('\n');
		var p2=str.indexOf('\n', p1+1);
		tb.ttl=str.substring(0, p1);
		tb.url=str.substring(p1+1, p2);
		tb.quote=str.substring(p2+1);
		str=null;
		delete p1;
		delete p2;
		return tb;
	};//
	
	this.OtogiChange=function(){
		var chara=U.EI('charas').value;
		var pose=U.EI('poses').value;
		
		
		U.EI('otogichara').src='';
	};//

	this.FieldLoad=function(){
		var url=AJAX_BASE_URL+'otogi/descript.txt';
		var cb=this;
		callback=function(o){cb.FieldInit(o);};
		Dabten.Net.Load(url, callback, {async:true, force:false});
		return this;
	};//
	this.FieldInit=function(o){
		this.ParseSetting(o.client);
		this.LoadOtogi();

		delete this.ParseSetting;
		delete this.LoadOtogi;
		return this;
	};//
	this.ParseSetting=function(client){
		if(client.status!=0 && client.status!=200 && client.status!=304){
			return this;
		}
		var lines=client.responseText.split(LF);
		LINES:for(var l=0,line,r={key:'',val:''},p,dir='',kid='',prs=props,reg=new RegExp('.');l<lines.length;l++){
			line=U.Trim(lines[l]);
			if(!line.length || line.charAt(0)=='#')
				continue LINES;

			if(dir=='otogi'){
				if(reg.test(line)){
					dir='';
					continue LINES;
				}else if(line.charAt(0)=='<'){ //kid
					kid=(line.search('^</'+kid+'>')!=-1)?'':line.substring(1, line.length-1);
					continue LINES;
				}
				
				if(!kid||!GetProp(line, r)){
					continue LINES;
				}
				if(typeof props.otogis[kid]=='undefined')
					props.otogis[kid]={};
				props.otogis[kid][r.key]=r.val;
			
			}else if(dir==''){
			
				if(line.charAt(0)=='<'){
				//ディレクティブ
					dir=(line.charAt(1)=='/')?'':line.substring(1, line.length-1);
					reg.compile('^</'+dir+'>');
					continue LINES;
				}
				
				if(!GetProp(line, r))
					continue LINES;
				
				if(U.ArrayInclude(r.key, addprops)){
				// 追加型プロパティーは配列に追加
					if(typeof props[r.key]=='undefined')
						props[r.key]=[];
					props[r.key].push(r.val);
				}else{
				// 既存プロパティーに上書き
					props[r.key]=r.val;
				}

			}else{ //if(dir)
				
			}

		}//LINES:for
		delete GetProp;
		return this;
		
		/****/
		function GetProp(line, r){
			var p=line.indexOf(' ');
			if(p==-1)
				p=line.indexOf('\t');
			r.key=line.substring(0, p);
			r.val=U.Trim(line.substring(p+1));
			if(r.val=='false')
				r.val=false;
			return !!r.key;
		}
	};
}//

var otogi=new Otogi();

U.AE(window, 'load', otogi.OnLoad);

